<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: /home/x/siggen/test/test_with_ref.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('test__with__ref_8cpp_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">test_with_ref.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#define BOOST_TEST_MODULE TestSigGen</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#include &lt;boost/test/unit_test.hpp&gt;</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &quot;SigGen.h&quot;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &quot;Options.h&quot;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &quot;Logging.h&quot;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;md5sum.h&quot;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;BOOST_AUTO_TEST_CASE( crosscheck_with_ref_impl )</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;{</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;    siggen::initLogging(3);</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    {</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        std::vector&lt;char&gt; siggen_buff;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        std::vector&lt;char&gt; md5sum_buff;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        std::string inputFile(<span class="stringliteral">&quot;test1024.bin&quot;</span>);</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        <span class="keywordtype">size_t</span> <span class="keyword">const</span> bs = 1024 * 1024;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        {</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;            <a class="code" href="classsiggen_1_1_options.html">siggen::Options</a> options;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;            options.<a class="code" href="classsiggen_1_1_options.html#a2a83396bdb1535acb324b827d064ac6f">SetInputFileName</a>(inputFile);</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;            <span class="comment">//options.SetOutputFileName; // no output file</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;            options.<a class="code" href="classsiggen_1_1_options.html#a29f02029bc74a0212fd506a99e0b36ef">SetBlockSize</a>(bs);</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;            options.<a class="code" href="classsiggen_1_1_options.html#aa2797de5dce12cb7751c942504e51074">SetThreadCount</a>(2);</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;            options.<a class="code" href="classsiggen_1_1_options.html#a80cdeac333c31612aa82608fcd1c7a41">SetThreadPolicy</a>(siggen::ThreadingPolicy::PowerSaver);</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;            options.<a class="code" href="classsiggen_1_1_options.html#ad716c1fe100084bd024029671caab830">SetLogLevel</a>(3);</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;            options.<a class="code" href="classsiggen_1_1_options.html#a064a446867e9329820973dbcf3fae9af">SetHashName</a>(<span class="stringliteral">&quot;md5&quot;</span>);</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160; </div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;            <a class="code" href="classsiggen_1_1_sig_gen.html">siggen::SigGen</a> sigGen(options);</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;            sigGen.ProcessToBuffer(siggen_buff);</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        }</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        {</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;            <span class="keywordflow">if</span> (FILE * fd = fopen(inputFile.c_str(), <span class="stringliteral">&quot;r&quot;</span>))</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;            {</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;                sum_blockwise_to_buff(fd, bs, md5sum_buff);</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;                fclose(fd);</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;            }</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;            <span class="keywordflow">else</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;                BOOST_ERROR(<span class="stringliteral">&quot;cannot open input file&quot;</span>);</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        }</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160; </div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        BOOST_REQUIRE(siggen_buff == md5sum_buff);</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    }</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;}</div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="aclasssiggen_1_1_options_html_a064a446867e9329820973dbcf3fae9af"><div class="ttname"><a href="classsiggen_1_1_options.html#a064a446867e9329820973dbcf3fae9af">siggen::Options::SetHashName</a></div><div class="ttdeci">void SetHashName(std::string const &amp;name)</div><div class="ttdoc">set user specified hash function name</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00060">Options.h:60</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html"><div class="ttname"><a href="classsiggen_1_1_options.html">siggen::Options</a></div><div class="ttdoc">configuration for generation of signatures file</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00020">Options.h:20</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_a29f02029bc74a0212fd506a99e0b36ef"><div class="ttname"><a href="classsiggen_1_1_options.html#a29f02029bc74a0212fd506a99e0b36ef">siggen::Options::SetBlockSize</a></div><div class="ttdeci">void SetBlockSize(size_t size)</div><div class="ttdoc">set user specified block size</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00052">Options.h:52</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_sig_gen_html"><div class="ttname"><a href="classsiggen_1_1_sig_gen.html">siggen::SigGen</a></div><div class="ttdoc">generates signature from input file and writes result to output file</div><div class="ttdef"><b>Definition:</b> <a href="_sig_gen_8h_source.html#l00014">SigGen.h:14</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_ad716c1fe100084bd024029671caab830"><div class="ttname"><a href="classsiggen_1_1_options.html#ad716c1fe100084bd024029671caab830">siggen::Options::SetLogLevel</a></div><div class="ttdeci">void SetLogLevel(uint32_t level)</div><div class="ttdoc">set user specified verbosity</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00058">Options.h:58</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_aa2797de5dce12cb7751c942504e51074"><div class="ttname"><a href="classsiggen_1_1_options.html#aa2797de5dce12cb7751c942504e51074">siggen::Options::SetThreadCount</a></div><div class="ttdeci">void SetThreadCount(uint32_t count)</div><div class="ttdoc">set user specified number of threads (0 == auto)</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00054">Options.h:54</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_a2a83396bdb1535acb324b827d064ac6f"><div class="ttname"><a href="classsiggen_1_1_options.html#a2a83396bdb1535acb324b827d064ac6f">siggen::Options::SetInputFileName</a></div><div class="ttdeci">void SetInputFileName(std::string const &amp;name)</div><div class="ttdoc">set user specified input file name</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00048">Options.h:48</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_a80cdeac333c31612aa82608fcd1c7a41"><div class="ttname"><a href="classsiggen_1_1_options.html#a80cdeac333c31612aa82608fcd1c7a41">siggen::Options::SetThreadPolicy</a></div><div class="ttdeci">void SetThreadPolicy(ThreadingPolicy policy)</div><div class="ttdoc">set user specified threading policy</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00056">Options.h:56</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_13e138d54eb8818da29c3992edef070a.html">test</a></li><li class="navelem"><b>test_with_ref.cpp</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
